package com.liang.dao;

import com.liang.entity.PrjAnnualbudget;
import com.liang.entity.PrjContract;
import com.liang.entity.PrjProject;
import com.liang.entity.StaPayapproval;
import org.apache.ibatis.annotations.Param;
import org.springframework.data.domain.Pageable;

import java.util.List;
import java.util.Map;

/**
 * 付款申请(StaPayapproval)表数据库访问层
 *
 * @author makejava
 * @since 2023-06-05 16:03:48
 */
public interface StaPayapprovalDao {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    StaPayapproval queryById(Integer id);

    /**
     * 查询指定行数据
     *
     * @param staPayapproval 查询条件
     * @param pageable       分页对象
     * @return 对象列表
     */
    List<StaPayapproval> queryAllByLimit(StaPayapproval staPayapproval, @Param("pageable") Pageable pageable);

    /**
     * 统计总行数
     *
     * @param staPayapproval 查询条件
     * @return 总行数
     */
    long count(StaPayapproval staPayapproval);

    /**
     * 撤销数据（基本信息）
     *
     * @param staPayapproval 实例对象
     * @return 影响行数
     */
    int tjrevokeApprove(StaPayapproval staPayapproval);

    /**
     * 新增数据
     *
     * @param staPayapproval 实例对象
     * @return 影响行数
     */
    int insert(StaPayapproval staPayapproval);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<StaPayapproval> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<StaPayapproval> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<StaPayapproval> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<StaPayapproval> entities);

    /**
     * 修改数据
     *
     * @param staPayapproval 实例对象
     * @return 影响行数
     */
    int update(StaPayapproval staPayapproval);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Integer id);

    /**
     * 获取付款申请列表
     *
     * @return
     */
    List<StaPayapproval> getFksqList(Map map);

    /**
     * 批量删除付款申请
     *
     * @param idList
     * @return
     */
    int batchDelete(List<Integer> idList);

    /**
     * 修改审批状态
     *
     * @param staPayapproval 实例对象
     * @return 实例对象
     */
    int updateSpzt(StaPayapproval staPayapproval);


    List<StaPayapproval> getFksq(Map map);

    List<StaPayapproval> queryByHtId(Integer id);

    StaPayapproval getYFKJE(String fysq);

    List<StaPayapproval> getFkjh(Integer id);

    Double selectPayByFkjh(Integer id);


    List<PrjAnnualbudget> getNdfk(Map map);

    void updateHtje(PrjContract prjContract);


    List<PrjAnnualbudget> getXmzys(Map map);
}

